# USB VFD
A USB enabled vacuum fluorencent display.
![Photo](hardware/photo.jpg)

## Hardware
The board is based around the Samsung HCS-12SS59T which can be ordered at Pollin (at the time of writing this): https://www.pollin.de/p/vakuum-fluoreszenzdisplay-samsung-hcs-12ss59t-12x1-121466

![Schematic](hardware/schematic.png)

## Bootloader
A USBASP based bootloader for the board. To enter it, push the button during powerup.

## Firmware
An AVR-CDC based firmware providing a serial terminal (```/dev/ttyACMx```) with the following commands:
* Set text: ```t<12b ASCII>```
* Set raw: ```T<12b RAW>```
* Set brightness: ```b<0\15> / B<RAW>```
* Shift text: ```s<ASCII>...```
* Set character RAM: ```C<0-15><2b character>```
* Reset LCD: ```r```
* Reset board: ```R```
* Enable progress bar mode: ```xx```
* Set progress bar: ```x<0-60> <0-60> / X<2b progress>```

Each command needs to be followed by a carriage return and / or a newline.

## License
All code is released under the GNU GPL Version 2. See LICENSE.TXT for more info.
